/***************************************************************************
 Copyright (C) 2007 Christoph Reichenbach <reichenb@colorado.edu>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public Licence as
 published by the Free Software Foundaton; either version 2 of the
 Licence, or (at your option) any later version.

 It is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 merchantability or fitness for a particular purpose. See the
 GNU General Public Licence for more details.

 You should have received a copy of the GNU General Public Licence
 along with this program; see the file COPYING. If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

***************************************************************************/

package edu.colorado.cs;

import java.util.Set;
import java.util.HashSet;

public class IceRoom extends Room
{
	protected boolean is_slippery = true;
	protected Set<Direction> iced_directions = new HashSet<Direction>();

	public IceRoom(Direction iced_direction)
	{
		super ("Ice room", "You shiver as you enter the room.  Ice covers the walls and the floor.  A steep slope leads up towards the east,\n"
		       + "though it looks quite slippery.");

		iced_directions.add(iced_direction);
	}

	public void
	put(Item i)
	{
		if (i instanceof IceMelterItem) {
			((IceMelterItem) i).meltIce();
			this.is_slippery = false;
		}

		super.put(i);
	}

	public Room
	tryExit(Direction d)
	{
		Room result = super.getExit(d);
		if (result == null)
			return null;

		if (this.is_slippery
		    && iced_directions.contains(d)) {
			System.out.println("(Ouch)\nBad idea.\nThis slope is an extraordinarily slippery one; your attempt to climb up failed miserably.\n");

			return null;
		} else
			return result;
	}
}
