/***************************************************************************
 Copyright (C) 2007 Christoph Reichenbach <reichenb@colorado.edu>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public Licence as
 published by the Free Software Foundaton; either version 2 of the
 Licence, or (at your option) any later version.

 It is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 merchantability or fitness for a particular purpose. See the
 GNU General Public Licence for more details.

 You should have received a copy of the GNU General Public Licence
 along with this program; see the file COPYING. If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

***************************************************************************/

package edu.colorado.cs;

public class Item extends GameObj
{
	private StorageInterface storage;

	public Item(StorageInterface storage, String name, String description)
	{
		super(name, description);
		this.storage = storage;
		this.storage.put(this);
	}

	/* Removed:  This is better handled in Storage */
// 	private void
// 	remove()
// 	{
// 		if (this.storage != null) {
// 			this.storage.remove(this);
// 			this.storage = null;
// 		}
// 	}

	public void
	setStorage(StorageInterface s)
	{
//		this.remove();
		this.storage = s;
	}

	public StorageInterface
	getStorage()
	{
		return this.storage;
	}

	/**
	 * Generate an effect if someone tries to pick up this item
	 *
	 */
	public Item
	pickUp()
	{
		return this;
	}

	/**
	 * toString is called implicitly whenever we try to print this object
	 *
	 * @return A stringification of the object
	 */
	public String
	toString()
	{
		return this.getName();
	}

	public void
	use()
	{
		System.out.println("Nothing happens.\n");
	}
}
