/***************************************************************************
 Copyright (C) 2007 Christoph Reichenbach <reichenb@colorado.edu>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public Licence as
 published by the Free Software Foundaton; either version 2 of the
 Licence, or (at your option) any later version.

 It is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 merchantability or fitness for a particular purpose. See the
 GNU General Public Licence for more details.

 You should have received a copy of the GNU General Public Licence
 along with this program; see the file COPYING. If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

***************************************************************************/

package edu.colorado.cs;

public class PortalRoom extends Room implements MagicInterface
{
	protected Direction portal_direction;
	protected Room other_room;
	protected RoomReader current_room_reader;
	boolean magic_used = false;

	public PortalRoom(Direction portal_direction, Room other_room, RoomReader current_room_reader)
	{
		super ("Portal room", "This room is bare, except for odd chalk markings on the " + portal_direction.toString().toLowerCase() + "ern wall.\n"
		       + "Someone appears to have drawn the outline of a door there.");
		this.portal_direction = portal_direction;
		this.other_room = other_room;
		this.current_room_reader = current_room_reader;
	}

	public void
	magic()
	{
		if (magic_used)
			System.out.println("Nothing happens.\n");
		else {
			magic_used = true;
			setExit(portal_direction, other_room);

			if (current_room_reader.getRoom() == this) {
				System.out.println("Suddenly, the wall lights up and a new doorway appears on the " + portal_direction.toString().toLowerCase() + "ern wall.");
				this.description = "Scorch markings on the " + portal_direction.toString().toLowerCase() + "ern exit witness its recent creation.";
			} else
				System.out.println("For an instant, you hear a humming sound in the distance.");
		}
	}
}
