/***************************************************************************
  Copyright (C) 2007 Christoph Reichenbach


 This program may be modified and copied freely according to the terms of
 the GNU general public license (GPL), as long as the above copyright
 notice and the licensing information contained herein are preserved.

 Please refer to www.gnu.org for licensing details.

 This work is provided AS IS, without warranty of any kind, expressed or
 implied, including but not limited to the warranties of merchantability,
 noninfringement, and fitness for a specific purpose. The author will not
 be held liable for any damage caused by this work or derivatives of it.

 By using this source code, you agree to the licensing terms as stated
 above.


 Please contact the maintainer for bug reports or inquiries.

 Current Maintainer:

    Christoph Reichenbach (CR) <jameson@linuxgames.com>

***************************************************************************/

package edu.colorado.cs;

import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

public class Storage implements StorageInterface
{
	private Map<String, Item> contents = new HashMap<String, Item>();
	protected String name;

	public Storage(String name)
	{
		this.name = name;
	}

	public String
	getName()
	{
		return this.name;
	}

	public void
	put(Item i)
	{
		i.getStorage().getStorage().remove(i);
		i.setStorage(this);
		this.contents.put(i.getName().toUpperCase(), i);
	}

	protected void
	remove(Item i)
	{
		contents.remove(i.getName().toUpperCase());
	}

	public Item
	get(String s)
	{
		return this.contents.get(s);
	}

	public boolean
	isEmpty()
	{
		return this.contents.isEmpty();
	}

	public String
	getContentsNames()
	{
		return Utility.concatWith("nothing",
					  "",
					  "",
					  this.contents.values());
	}

	public Storage
	getStorage()
	{
		return this;
	}
}
