/***************************************************************************
 Copyright (C) 2007 Christoph Reichenbach <reichenb@colorado.edu>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public Licence as
 published by the Free Software Foundaton; either version 2 of the
 Licence, or (at your option) any later version.

 It is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 merchantability or fitness for a particular purpose. See the
 GNU General Public Licence for more details.

 You should have received a copy of the GNU General Public Licence
 along with this program; see the file COPYING. If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

***************************************************************************/

package edu.colorado.cs;

import java.util.Collection;
import java.util.Iterator;

public class Utility
{

	public static String concatWith(String empty,
					String one,
					String many,
					Collection<?> elements)
	{
		String description = "";

		if (elements.isEmpty())
			description += empty;
		else {
			Iterator<?> it = elements.iterator();

			if (elements.size() == 1)
				description += one + it.next();
			else {
				description += many;

				if (elements.size() == 2)
					description += it.next() + " and " + it.next();
				else for (int i = elements.size() - 1; i >= 0; --i) {
					description += it.next();
					if (i == 1)
						description += " and ";
					else if (i > 0)
						description += ", ";
				}
			}
		}

		return description;
	}
}
