/***************************************************************************
 Copyright (C) 2007 Christoph Reichenbach <reichenb@colorado.edu>

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public Licence as
 published by the Free Software Foundaton; either version 2 of the
 Licence, or (at your option) any later version.

 It is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 merchantability or fitness for a particular purpose. See the
 GNU General Public Licence for more details.

 You should have received a copy of the GNU General Public Licence
 along with this program; see the file COPYING. If not, write to
 the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.

***************************************************************************/

package edu.colorado.cs;

import java.util.Map;
import java.util.HashMap;

public class Wand extends Item implements MagicInterface
{
	protected ReaderInterface reader;
	protected Map<String, MagicInterface> magic_subjects = new HashMap<String, MagicInterface>();

	public Wand(Room room, ReaderInterface reader)
	{
		super(room, "wand", "A somewhat crooked looking wand.  Someone appears to have duct-taped a phoenix feather to it in a somewhat misguided attempt at making it more powerful.");
		this.reader = reader;
	}

	public void
	setMagicSubjects(MagicInterface [] subjects)
	{
		for (int i = 0; i < subjects.length; i++)
			magic_subjects.put(subjects[i].getName().toUpperCase(),
					   subjects[i]);
	}

	public void
	magic()
	{
		System.out.println("The wand heats up, and begins to vibrate in your hands.  You find yourself forced to let it go.\nIt continues to levitate in the air for a while longer.  You stand and stare, unable to touch it.");

		Storage limbo = new Storage("limbo");
		limbo.put(this); /* This removes it from the inventory. */

		System.out.println("Suddently, seemingly out of nowhere, a mark-and-sweep demon comes along.\n  ``This wand has no remaining references to it'', he proclaims, picks it up, and vanishes.\n");
		System.out.println("You are left astonished and wandless.\n");
	}

	public void
	use()
	{
		System.out.println("As you wave the wand, a mesage box manifests itself in the air before you.");
		System.out.println("``Please speak out the name of whatever entity's magic you want to invoke!''");
		String entity_name = reader.readInput("You say: ");
		MagicInterface item = magic_subjects.get(entity_name.toUpperCase());

		if (item == null)
			System.out.println("``I do apologise, but this feature is only available in the registered version.''");
		else {
			System.out.println("``Very well.''\nThe wand begins to glow.");
			item.magic();
		}
	}
}
